# StreamPair

[![NPM version](https://badge.fury.io/js/socket-pair.svg)](http://badge.fury.io/js/socket-pair)

A pair of coupled sockets.

Similar to `stream-pair`, but with sockets with real fds. A workaround for <https://github.com/nodejs/node/issues/12716>.

## Usage

```javascript
var socketPair = require('socket-pair');

socketPair.create(function (pair) {
  var a = pair.client;
  var b = pair.connection;

  a.write('123');
  b.on('data', function (chunk) {
    console.log(chunk.toString('utf8'));
  });

  socketPair.closeAll();
});
```

## API

```
socketPair.create(cb)     // creates or reuses a socket server
socketPair.closeAll()     // closes the server and all sockets
```
