'use strict';

var server;
var listening = false;
var sock;

function createServer(prefix) {
	var os = require('os');
	var net = require('net');
	var path = require('path');
  var sockname = (prefix || 'node-socket-pair') + '.' + require('crypto').randomBytes(16).toString('hex') + '.sock';

  if (/win/.test(os.platform())) {
    sock = path.join('\\\\?\\pipe', process.cwd(), sockname);
  }
  else {
    sock = path.join(os.tmpdir(), sockname);
  }

  server = net.createServer();
}

exports.create = function create(cb, prefix) {
	var net = require('net');
	var writer;

	// This server listens on a Unix socket or Windows pipe at 'sock'
  if (!server) {
    createServer(prefix);
  }
  if (!listening) {
    server.listen(sock, function () {
 		  writer = net.connect(sock);
      listening = true;
    });
  }

  server.once('connection', function each(reader) {
    cb({ reader: reader, writer: writer });
  });

  if (listening) {
 		writer = net.connect(sock);
  }
};

exports.closeAll = function () {
  if (server) {
    server.close();
  }
};
